/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Fr Mr 25 23:25:51 CET 2005
    copyright            : (C) 2005 by Jeff Breker Arnold Schiller
    email                : schiller@babsi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

  
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int strtonum(char *str);
void help(void);
void badinput(char *str);
void noparse(char *str);

int main(int argc, char *argv[])
{
	int numvar = 1;
	int lowvar = 1;
	int uppvar = 1;
	int noalign = 0;
	int size = 8;
	int num = 1;
	int line = 80;
	int ntmp = 0;
	int i = 0;
	int j = 0;
	int k = 0;

	char ctmp[255];

	srand(time(NULL));

	for(i = 1; i < argc; ++i)
	{
		j = 0;
		ctmp[0] = *argv[i];
		while(*argv[i] != 0)
		{
			++argv[i];
			++j;
			ctmp[j] = *argv[i];
		}
		if(strcmp(ctmp, "--help") == 0)
		{
			help();
			return 0;
		}
                if(strcmp(ctmp, "-h") == 0)
		{
			help();
			return 0;
		}
		if(strcmp(ctmp, "-v") == 0)
		{
			printf("Version 1.21\n");
			return 0;
		}
		if(strcmp(ctmp, " ") == 0)
		{
			help();
			return 0;
		}
		if(strcmp(ctmp, "-l") == 0)
		{
			j = 0;
			++i;
			ctmp[0] = *argv[i];
			while(*argv[i] != 0)
			{
				++argv[i];
				++j;
				ctmp[j] = *argv[i];
			}

			if((ntmp = strtonum(ctmp)) >= 1)
				line = ntmp;
			else
				if(ntmp == 0)
				{
					badinput(ctmp);
					help();
					return 0;
				}
		}
		else
			if(strcmp(ctmp, "-n") == 0)
			{
				j = 0;
				++i;
				ctmp[0] = *argv[i];
				while(*argv[i] != 0)
				{
					++argv[i];
					++j;
					ctmp[j] = *argv[i];
				}

				if((ntmp = strtonum(ctmp)) >= 1)
					num = ntmp;
				else
					if(ntmp == 0)
					{
						badinput(ctmp);
						return 1;
					} 
					
						

			}
			else
				if(strcmp(ctmp, "-na") == 0)
					noalign = 1;
				else
					if(strcmp(ctmp, "-s") == 0)
					{
						j = 0;
						++i;
						ctmp[0] = *argv[i];
						while(*argv[i] != 0)
						{
							++argv[i];
							++j;
							ctmp[j] = *argv[i];
						}
						if((ntmp = strtonum(ctmp)) > 0)
							size = ntmp;
						else
							if(ntmp == 0)
							{
								badinput(ctmp);
								return 1;
							}
					}
					else
						if(strcmp(ctmp, "-upp") == 0)
							uppvar = 0;
						else
							if(strcmp(ctmp, "-low") == 0)
								lowvar = 0;
							else
								if(strcmp(ctmp, "-num") == 0)
									numvar = 0;
								else
								if(strcmp(ctmp, "-"))
									help();
								
								else
								{
									noparse(ctmp);
									return 1;
								}
	}
	if((uppvar == 0) && (lowvar == 0) && (numvar == 0))
		return 1;
	if(noalign == 0)
	{
		for(i = 0; ((i * size) + i -1) <= line; ++i)
			j = (i * (size + 1)) - 1;
		line = j;
	}
	i = j =  k = 0;

	while(1 == 1)
	{
		if(i == num)
		{
			printf("\n\n");
			return 0;
		}

		ntmp = rand() / (RAND_MAX / 62);
		if((ntmp >= 0) && (ntmp <= 9) && (numvar == 1))
			printf("%c", ntmp + 48);
		else
			if((ntmp >= 10) && (ntmp <= 35) && (uppvar == 1))
				printf("%c", ntmp + 55);
			else
				if((ntmp >= 36) && (ntmp <= 61) && (lowvar == 1))
					printf("%c", ntmp + 61);
				else
				{
					--k;
					--j;
				}
		++k;
		++j;

		if((j == line) && (k == size))
		{
			j = k = 0;
			++i;
			printf("\n");
		}
		else
			if(j == line)
			{
				j = 0;
				printf("\n");
			}
			else
				if(k == size)
				{
					++i;
					++j;
					k = 0;
					printf(" ");
				}
	}
	help();
	return 1;
}

int strtonum(char *str)		/* takes a string and changes it into an */
{				/* integer. Any non numbers produce an error. */
	int i = 0;
	int num = 0;
	int len = 0;
	int j = 0;
	int exponent = 0;
        int err = 0;
	len = strlen(str);
	for(i = 0; i < len; ++i)
	{
		exponent = 1;
		if(str[i] >= 48 && str[i] <= 57)
		{
			for(j = 0; j < (len - 1 - i); ++j)
				exponent *= 10;
			num += ((str[i] - 48) * exponent);
		}
		else
			err++;
	}
        if(num == 0)
	{
		return 1;
	}
	else
	if(err > 0)
	{
		return num;
	}
        else
	
	return num;
}

void help(void)
{
	printf("Version: 1.2\n");
	printf("Usage: genpasswd [options]\n\n");
	printf("Options:\n");
	printf("     -l <#>  maximum characters per line       default = 80\n");
	printf("     -n <#>  number of passwords to output     default = 1\n");
	printf("     -s <#>  size of desired passwords         default = 8\n");
	printf("     -na     no alignment, do not columnize output\n");
	printf("     -num    do not generate passwords with numbers\n");
	printf("     -low    do not generate passwords with lower case characters\n");
	printf("     -upp    do not generate passwords with upper case characters\n\n");
	printf("              Copyright (C) 2002 Jeff Breker\n");
	printf("      -v      Version: 1.2\n");
	printf("This program is free software; you can redistribute it\n");
	printf("and/or modify it under the terms of the GNU General Public\n");
	printf("License as published by the Free Software Foundation;\n");
	printf("either version 2 of the License, or (at your option) any\n");
	printf("later version.\n\n");
        printf("Example: genpasswd -l 10 -n 3 -s 10 \n");
	return;
}

void noparse(char *str)
{
	printf("Unable to parse: %s", *str);
	return;
}

void badinput(char *str)
{
	printf("Invalid Input: %s", *str);
	return;
}
